package com.hys.app.mapper.goods;

import com.hys.app.framework.context.user.AdminUserContext;
import com.hys.app.framework.database.WebPage;
import com.hys.app.framework.database.mybatisplus.base.BaseMapperX;
import com.hys.app.framework.util.StringUtil;
import com.hys.app.model.erp.dos.GoodsDO;
import com.hys.app.model.erp.dos.GoodsSnDO;
import com.hys.app.model.erp.dto.GoodsQueryParams;
import com.hys.app.model.erp.dto.GoodsSnQueryParams;
import com.hys.app.model.goods.vo.GoodsParamsVO;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 商品的Mapper
 *
 * @author 张崧
 * 2023-12-26 15:56:58
 */
public interface GoodsSnMapper extends BaseMapperX<GoodsSnDO> {

    default WebPage<GoodsSnDO> selectPage(GoodsSnQueryParams params) {
        return lambdaQuery()
                .likeIfPresent(GoodsSnDO::getSnCode, params.getSnCode())
                .likeIfPresent(GoodsSnDO::getSku, params.getSku())
                .eqIfPresent(GoodsSnDO::getStatus, params.getStatus())
                .eqIfPresent(GoodsSnDO::getCompanyId, AdminUserContext.getCompanyId())
                .orderByDesc(GoodsSnDO::getId)
                .page(params);
    }



    /**
     * 查询商品关联的参数及参数值
     * @return
     */
    List<GoodsSnDO> getGoodsSnCount(@Param("request")GoodsSnQueryParams params);

    /**
     * 查询商品关联的参数及参数值
     * @return
     */
    Long getGoodsSnCountQty(@Param("request")GoodsSnQueryParams params);




}

